% Three application codes need to be run respectively. 
%%
%%%%%%%%%%%%%%%%%%%%%%%%probability of risk occurrence increases at the growth rate 0.0020 %%%%%%%%%%%%
clear all;clc
A=xlsread('matrix.xls','sheet3');
[DeD,aver_DeD]=Degree_Distribution(A);
DeD;
for i=1:length(DeD)
    fenmu(i)=DeD(i)+sum(DeD(find((A(i,:)~=0))));
end
fenmu;
for i=1:length(DeD)
    Max_DeD(i)=(DeD(i)+sum(DeD(find((A(i,:)~=0)))))/max(fenmu);
end
Max_DeD;

n=0;
B=A;
C=A;
for i=1:size(B,1) 
    A(i,:)=[];
    A(:,i)=[];
    sharing(i)=sum(A(:));
    A=B;
end
share=(sum(C(:))-sharing)./sum(C(:));
bet=mean(share)*ones(1,size(A,1))./1;%td=1
for k=0:0.002:1
    local=1;
    I=zeros(1,size(A,1));
    lamuta=k*ones(1,size(A,1));
    I(local)=1;
    S(1,:)=I;
        Max_time=12;
        A(find(A~=0))=1;
        for t=1:Max_time
            I_lamuta=1-prod(repmat((1-lamuta),size(A,1),1).^(A.*repmat(I,size(A,1),1)),2);
            I(find(I_lamuta~=0))=1;
            S(t+1,:)=S(t,:)+(1-S(t,:)).*(I_lamuta'>Max_DeD);
            for j=1:size(A,1)
                if S(t+1,j)==1
                    S(t+1,j)=S(t+1,j)*(bet(j)>share(j));
                end
            end
        end
        n=n+1;
        x_k(n)=k;
        bilv=sum(S,2)/size(A,1);
        result(n)=bilv(Max_time);
end
plot(x_k,result,'-*')
%%
%%%%%%%%%%%%%%%%%%%%%%%%%probability without recovery increases at the growth rate 0.0020%%%%%%%%%%%
clear all;clc
A=xlsread('matrix.xls','sheet3');
[DeD,aver_DeD]=Degree_Distribution(A);
DeD;
for i=1:length(DeD)
    fenmu(i)=DeD(i)+sum(DeD(find((A(i,:)~=0))));
end
fenmu;
for i=1:length(DeD)
    Max_DeD(i)=(DeD(i)+sum(DeD(find((A(i,:)~=0)))))/max(fenmu);
end
Max_DeD;

n=0;
local=1;
I=zeros(1,size(A,1));
lamuta=mean(Max_DeD)*ones(1,size(A,1));
I(local)=1;
S(1,:)=I;
B=A;
C=A;
for i=1:size(B,1) 
    A(i,:)=[];
    A(:,i)=[];
    sharing(i)=sum(A(:));
    A=B;
end
share=(sum(C(:))-sharing)./sum(C(:));
for q=0:0.002:1
    bet=(1-q)*ones(1,size(A,1))./1;
    Max_time=12;
    A(find(A~=0))=1;
    for t=1:Max_time
        I_lamuta=1-prod(repmat((1-lamuta),size(A,1),1).^(A.*repmat(I,size(A,1),1)),2);
        I(find(I_lamuta~=0))=1;
        S(t+1,:)=S(t,:)+(1-S(t,:)).*(I_lamuta'>Max_DeD);
        for j=1:size(A,1)
            if S(t+1,j)==1
                S(t+1,j)=S(t+1,j)*(bet(j)>share(j));
            end
        end
    end
    bilv=sum(S,2)/size(A,1);
    n=n+1;
    x_q(n)=q;
    result(n)=bilv(Max_time);
end
x_q_plot=x_q';
result_plot=result';
plot(x_q_plot,result_plot,'-*')
%%
%%%%%%%%%%%%%%%%%%%%%%%%%two probability increases at the growth rate 0.0020%%%%%%%%%%%
clear all;clc
A=xlsread('matrix.xls','sheet3');
[DeD,aver_DeD]=Degree_Distribution(A);
DeD;
for i=1:length(DeD)
    fenmu(i)=DeD(i)+sum(DeD(find((A(i,:)~=0))));
end
fenmu;
for i=1:length(DeD)
    Max_DeD(i)=(DeD(i)+sum(DeD(find((A(i,:)~=0)))))/max(fenmu);
end
Max_DeD;

n=0;
m=0;
B=A;
C=A;
for i=1:size(B,1)
    A(i,:)=[];
    A(:,i)=[];
    sharing(i)=sum(A(:));
    A=B;
end
share=(sum(C(:))-sharing)./sum(C(:));
for k=0:0.0020:1
    local=1;
    I=zeros(1,size(A,1));
    lamuta=k*ones(1,size(A,1));
    I(local)=1;
    S(1,:)=I;
    for q=0:0.0020:1
        bet=q*ones(1,size(A,1))./1;%td=1
        Max_time=12;
        A(find(A~=0))=1;
        for t=1:Max_time
            I_lamuta=1-prod(repmat((1-lamuta),size(A,1),1).^(A.*repmat(I,size(A,1),1)),2);
            I(find(I_lamuta~=0))=1;
            S(t+1,:)=S(t,:)+(1-S(t,:)).*(I_lamuta'>Max_DeD);
            for j=1:size(A,1)
                if S(t+1,j)==1
                    S(t+1,j)=S(t+1,j)*(bet(j)>share(j));
                end
            end
        end
        n=n+1;
        bilv=sum(S,2)/size(A,1);
        result(n)=bilv(Max_time);
    end
    m=m+1;
end
zz=reshape(result,m,m);
[xx,yy]=meshgrid(0:0.0020:1,0:0.0020:1);
mesh(xx, yy, zz)




